"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importDefault(require("react"));
// create empty context as default
const StorageContext = react_1.default.createContext({});
const AttachStorage = (props) => {
    return react_1.default.createElement(StorageContext.Provider, { value: {
            addRenderSsr: props.addToRenderList,
            config: props.config,
            isOffline: props.isOffline,
            preloadedFiles: props.preloadedFiles,
            renderListResults: props.renderListResults
        } }, props.children);
};
exports.serviceWithStorage = (complementedCallback) => {
    // we return an array of valid middleware-callbacks
    return [
        function (req, res, next) {
            return __awaiter(this, void 0, void 0, function* () {
                return yield complementedCallback(req.listFiles, req, res, next);
            });
        }
    ];
};
exports.serviceAttachStorage = (listFiles) => {
    return (req, res, next) => {
        req.listFiles = listFiles;
        next();
    };
};
function withStorageSsrRendering(Component) {
    return function WrapperComponent(props) {
        return (react_1.default.createElement(StorageContext.Consumer, null, (context) => {
            return react_1.default.createElement(Component, Object.assign({}, props, { renderSsr: context.addRenderSsr, config: context.config, isOffline: context.isOffline, preloadedFiles: context.preloadedFiles, renderListResults: context.renderListResults }));
        }));
    };
}
exports.withStorageSsrRendering = withStorageSsrRendering;
exports.default = AttachStorage;
//# sourceMappingURL=attach-storage.js.map